





#include <lpc17xx.h>
#include "uart.h"
#include "Finger.h"











/************************verify the module password***********************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
contetnt: password to be verify
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_verify_psw 	(unsigned int password)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x07,0x13},buff[16];
command [10]= password>>6;
command [11]= password>>4;
command [12]= password>>2;
command [13]= password&0xFF;
i=command [6] + command [7] + command [8] + command [9] + command [10] + command [11] + command [12] + command [13];
command [14]=i>>8;
command [15]=i&0xFF;
UART0_SendString (command,16);
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;
};

/************************set the module password***********************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
contetnt: password to be set
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_set_psw 		(unsigned int password)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x07,0x12},buff[16];
command [10]= password>>6;
command [11]= password>>4;
command [12]= password>>2;
command [13]= password&0xFF;
i=command [6] + command [7] + command [8] + command [9] + command [10] + command [11] + command [12] + command [13];
command [14]=i>>8;
command [15]=i&0xFF;
UART0_SendString(command,16); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;	
};

/************************set the module address***********************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
contetnt: address to be set
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_set_address	(unsigned int address)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x07,0x15},buff[16];
command [10]= address>>6;
command [11]= address>>4;
command [12]= address>>2;
command [13]= address&0xFF;
i=command [6] + command [7] + command [8] + command [9] + command [10] + command [11] + command [12] + command [13];
command [14]=i>>8;
command [15]=i&0xFF;
UART0_SendString(command,16); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;	
};

/************************set the module system parametr***********************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
parametr: Operation parameter to be settings
contetnt: data of parametr to be set
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_set_syspar	(unsigned char paramtype , unsigned char paramvalue)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x05,0x0e},buff[16];
command [10]= paramtype;
command [11]= paramvalue;
i=command [6] + command [7] + command [8] + command [9] + command [10] + command [11];
command [12]=i>>8;
command [13]=i&0xFF;
UART0_SendString(command,16); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;	
};

/************************module Port control***********************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
contetnt: uart port controll command=> Control code ”0” means turns off the port; Control code ”1” means turns on the port;
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_port_control	(unsigned char controlcode )
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x04,0x17},buff[16];
command [10]= controlcode;
i=command [6] + command [7] + command [8] + command [9] + command [10] ;
command [11]=i>>8;
command [12]=i&0xFF;
UART0_SendString(command,16); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;		
};

/************************read the module system parametr***********************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_get_syspar	(unsigned char *str)
{
unsigned int response,i,j=0;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x0f,0x00 , 0x13},buff[32];
UART0_SendString(command,16); 
for (i=0;i<28;i++)	buff[i]=UART0_GetChar();
response=buff[9];
for (i=10;i<26;i++) {
str[j]=buff[i];
j++;
}
return response;	
};

/************************Read valid template number***********************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_get_temp_numb	(unsigned int *tmpnom)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x1d,0x00,0x21},buff[32];
UART0_SendString(command,12); 
for (i=0;i<14;i++)	buff[i]=UART0_GetChar();
response=buff[9];
*tmpnom=buff[10]*256+buff[11];
return response;	
};

/********detecting finger and store the detected finger image in ImageBuffer***************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_enroll(void)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x01,0x00,0x05},buff[16];
UART0_SendString(command,12); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;	
};

/********to send the image in Img_Buffer module to mcu***************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_get_fing_img			(unsigned int *str )
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x0a,0x00,0x0e},buff[16];
UART0_SendString(command,12); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
for (i=0;i<128;i++)	str[i]=UART0_GetChar();

return response;	
};

/********to write the image in mcu to Img_Buffer module***************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_send_fing_img			(unsigned char *str )
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x0b,0x00,0x0f},buff[16];
UART0_SendString(command,12); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
for (i=0;i<128;i++)	UART0_SendString (str,128);
return response;	
};

/******************store finger in buffer1 or buffer2*******************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
bufferid: BufferID is CharBuffer1 or CharBuffer2 are 1h and 2h respectively.
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_store_fingtobuf12		(unsigned char buffid)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x04,0x02},buff[16];
command[10]=buffid;
command[11]=0x00;
i=command [6] + command [7] + command [8] + command [9] + command[10] ;
command [11]=i>>8;
command [12]=i&0xFF;
UART0_SendString(command,13); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];


return response;	
};

/********convert finger data from buff1 or buff2 to template data to buff1 or buff2***************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_fing_to_temp			(void)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x05,0x00,0x09},buff[16];
UART0_SendString(command,12); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;	
};

/******************get template from buffer to mcu*******************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
bufferid: BufferID is CharBuffer1 or CharBuffer2 are 1h and 2h respectively.
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_get_fing_temp			(unsigned char buffid , unsigned char *str)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x04,0x08},buff[16];
command[10]=buffid;
i=command [6] + command [7] + command [8] + command [9] + command[10] ;
command [11]=i>>8;
command [12]=i&0xFF;
UART0_SendString(command,12); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
for (i=0;i<128;i++)	str[i]=UART0_GetChar();
return response;	
};

/******************send template from mcu tu buffer *******************************
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
bufferid: BufferID is CharBuffer1 or CharBuffer2 are 1h and 2h respectively.
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_send_fing_temp			(unsigned char buffid , unsigned char *str )
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x04,0x09},buff[16];
command[10]=buffid;
command[i]=command [6] + command [7] + command [8] + command [9] + command[10] ;
command [11]=i>>8;
command [12]=i&0xFF;
UART0_SendString(command,12); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
UART0_SendString(str,128);
return response;	
};

/*****to store the template of specified buffer (Buffer1/Buffer2) at the designated location of Flash library.****
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
bufferid: BufferID is CharBuffer1 or CharBuffer2 are 1h and 2h respectively.
location: Flash location of the template, two bytes with high byte front and low byte behind
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_store_fing_temp			(unsigned char buffid , unsigned int locid )
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x06,0x06},buff[16];
command[10]=buffid;
command[11]=locid>>8;
command[12]=locid&0xFF;
i=command [6] + command [7] + command [8] + command [9] + command[10] + command[11] + command[12] ;
command [13]=i>>8;
command [14]=i&0xFF;
UART0_SendString(command,15); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;		
};

/*****to load template at the specified location (PageID) of Flash library to template buffer CharBuffer1/CharBuffer2****
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
bufferid: BufferID is CharBuffer1 or CharBuffer2 are 1h and 2h respectively.
location: Flash location of the template, two bytes with high byte front and low byte behind
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_load_fing_temp			(unsigned char buffid , unsigned int pagenom )
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x06,0x07},buff[16];
command[10]=buffid;
command[11]=pagenom>>8;
command[12]=pagenom&0xFF;
i=command [6] + command [7] + command [8] + command [9] + command[10] + command[11] + command[12] ;
command [13]=i>>8;
command [14]=i&0xFF;
UART0_SendString(command,13); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;	
};

/*********delete (N) templates of Flash library started from the specified location (or PageID)**********
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
location: Flash location of the template, two bytes with high byte front and low byte behind
tempqt: nomber of template to be delete
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_delet_fing_temp			(unsigned int pagenom , unsigned int n)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x07,0x0c},buff[16];
command[10]=pagenom>>8;
command[11]=pagenom&0xFF;
command[12]=n>>8;
command[13]=n&0xFF;
i=command [6] + command [7] + command [8] + command [9] + command[10] + command[11] + command[12] + command[13] ;
command [14]=i>>8;
command [15]=i&0xFF;
UART0_SendString(command,16); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;		
};

/*********delete all templates of Flash library **********
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_delet_allfing_temp		(void)
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x0d,0x00,0x11},buff[16];
UART0_SendString(command,12); 
for (i=0;i<12;i++)	buff[i]=UART0_GetChar();
response=buff[9];
return response;		
};

/*********compare to template from buffer1 and buffer2**********
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_match_fing_temp			(unsigned int machscrore )
{
unsigned int response,i;
unsigned char command [16] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x03,0x03,0x00,0x07},buff[16];
UART0_SendString(command,12); 
for (i=0;i<14;i++)	buff[i]=UART0_GetChar();
machscrore=buff[10];
machscrore=(i=buff[11])<<8;
response=buff[9];
return response;	
};

/*********search template from buffer1 and buffer2 to flash library**********
input par: 
header: Fixed value of 0xEF01; High byte transferred first.
adress: this is module address. Default value is 0xFFFFFFFF, which can be modified by
command. High byte transferred first and at wrong adder value,
module will reject to transfer.
mode: Command packet=0x01 . data pakage=0x02 . response pakage=0x07 . end of data packet=0x08
len: Refers to the length of package content (command packets and
data packets) plus the length of Checksum( 2 bytes). Unit is
byte. Max length is 256 bytes. And high byte is transferred first.
insruction: type of command or data
bufferid: BufferID is CharBuffer1 or CharBuffer2 are 1h and 2h respectively.
firstloc: start serach frome this id
tempqt: nomber of template to be search
checksum: The arithmetic sum of package identifier, package length and
all package contens. Overflowing bits are omitted. high byte is
transferred first.
output par: module response 
*///////////////////////////////////////////////////////////////////////////////////
unsigned int Finger_search_fing_temp		(unsigned int* pagid , unsigned int* machscrore , unsigned char bufferid , unsigned int startpg , unsigned int pagnom )
{
unsigned int response,i;
unsigned char command [17] = {0xef,0x01,0xFF,0xFF,0xFF,0xFF,0x1,0x00,0x08,0x04},buff[16];
command[10]=bufferid;
command[11]=startpg>>8;
command[12]=startpg&0xFF;
command[13]=pagnom>>8;
command[14]=pagnom&0xFF;
i=command [6] + command [7] + command [8] + command [9] + command[10] + command[11] + command[12] + command[13] + command[14] ;
command [15]=i>>8;
command [16]=i&0xFF;
UART0_SendString(command,17); 
for (i=0;i<16;i++)	buff[i]=UART0_GetChar();

*pagid=(buff[10]<<8)|buff[11];
*machscrore=(buff[12]<<8)|buff[13];

response=buff[9];
return response;



};

/************************initial the finger print***********************************
input par: null
output par: null
*///////////////////////////////////////////////////////////////////////////////////
void Finger_Init 			(void)
{
//define irq pin
LPC_GPIO2->FIODIR |= (0<<0);
LPC_GPIO2->FIOCLR |=0x1;
#define Finger_irq LPC_GPIO2->FIODIR	&	0x01
Finger_verify_psw (0x00000000);

};


















