













#ifndef __FINGER_H
#define __FINGER_H


#include <lpc17xx.h>
#include "uart.h"

#define finger_int_port_num 3	
#define finger_int_pin_num 25




typedef enum {
 FINGERPRINT_OK= 0x00,
 FINGERPRINT_PACKETRECIEVEERR =0x01,
 FINGERPRINT_NOFINGER =0x02,
 FINGERPRINT_FINGERERR =0x03,
 FINGERPRINT_FINGTOCHARERR =0x06,
 FINGERPRINT_FINGTOCHARERR2 =0x07,
 FINGERPRINT_NOMATCH =0x08,
 FINGERPRINT_NOTFOUND =0x09,
 FINGERPRINT_NOCHARMATCH =0x0A,
 FINGERPRINT_NOFINGIDINLIB =0x0B,
 FINGERPRINT_TEMPERR =0x0C,
 FINGERPRINT_UPLTEMPERR =0x0D,
 FINGERPRINT_PACKETRESPONSEFAIL= 0x0E,
 FINGERPRINT_UPLOADFAIL =0x0F,
 FINGERPRINT_DELETEFAIL =0x10,
 FINGERPRINT_DBCLEARFAIL =0x11,
 FINGERPRINT_WRONGPASS =0x13,
 FINGERPRINT_INVALIDIMAGE =0x15,
 FINGERPRINT_FLASHERR =0x18,
 FINGERPRINT_INVERR =0x19,
 FINGERPRINT_INVALIDREG =0x1A,
 FINGERPRINT_INCORCONREG =0x1B,
 FINGERPRINT_PORTERR =0x1D,
	
}FINGRES;


///////RESPONSE//////////////////////////////
#define FINGERPRINT_OK 0x00
#define FINGERPRINT_PACKETRECIEVEERR 0x01
#define FINGERPRINT_NOFINGER 0x02
#define FINGERPRINT_FINGERERR 0x03
#define FINGERPRINT_FINGTOCHARERR 0x06
#define FINGERPRINT_FINGTOCHARERR2 0x07
#define FINGERPRINT_NOMATCH 0x08
#define FINGERPRINT_NOTFOUND 0x09
#define FINGERPRINT_NOCHARMATCH 0x0A
#define FINGERPRINT_NOFINGIDINLIB 0x0B
#define FINGERPRINT_TEMPERR 0x0C
#define FINGERPRINT_UPLTEMPERR 0x0D
#define FINGERPRINT_PACKETRESPONSEFAIL 0x0E
#define FINGERPRINT_UPLOADFAIL 0x0F
#define FINGERPRINT_DELETEFAIL 0x10
#define FINGERPRINT_DBCLEARFAIL 0x11
#define FINGERPRINT_WRONGPASS 0x13
#define FINGERPRINT_INVALIDIMAGE 0x15
#define FINGERPRINT_FLASHERR 0x18
#define FINGERPRINT_INVERR 0x19
#define FINGERPRINT_INVALIDREG 0x1A
#define FINGERPRINT_INCORCONREG 0x1B
#define FINGERPRINT_PORTERR 0x1D
/////////////////////////////////////////////
#define FINGERPRINT_STARTCODE 0xEF01
#define FINGERPRINT_STARTCODE 0xEF01


///////////Instruction codes //////////////////////
#define FINGERPRINT_COMMANDPACKET 0x1
#define FINGERPRINT_DATAPACKET 0x2
#define FINGERPRINT_RESPACKET 0x7
#define FINGERPRINT_ENDDATAPACKET 0x8

#define FINGERPRINT_TIMEOUT 0xFF
#define FINGERPRINT_BADPACKET 0xFE

#define FINGERPRINT_FINGTOIMG 0x01
#define FINGERPRINT_IMAGE2TZ 0x02
#define FINGERPRINT_MATCHTEMP 0x03
#define FINGERPRINT_SEARCHTEMP 0x04
#define FINGERPRINT_IMGTOTEMP 0x05
#define FINGERPRINT_STORETEMP 0x06
#define FINGERPRINT_LOADTEMP 0x07
#define FINGERPRINT_GETCHARIMG 0x08
#define FINGERPRINT_SENDCHARIMG 0x09
#define FINGERPRINT_DELETETEMP 0x0C
#define FINGERPRINT_EMPTYTEMP 0x0D
#define FINGERPRINT_VERIFYPASSWORD 0x13
#define FINGERPRINT_SETPASSWORD 0x12
#define FINGERPRINT_SETADDRESS 0x15
#define FINGERPRINT_SETPORT 0x17
#define FINGERPRINT_READNOMOFTEMP 0x1D
#define FINGERPRINT_GETIMG 0x0A
#define FINGERPRINT_SENDIMG 0x0B
#define FINGERPRINT_SETSYSPAR 0x0E
#define FINGERPRINT_READSYSPAR 0x0F
///////////////////////////////////////////////////////
#define FINGERPRINT_HISPEEDSEARCH 0x1B

//#define FINGERPRINT_DEBUG 

#define DEFAULTTIMEOUT 5000  // milliseconds





void Finger_Init 							(void);
unsigned int Finger_verify_psw 				(unsigned int password);
unsigned int Finger_set_psw 				(unsigned int password);
unsigned int Finger_set_address				(unsigned int address);
unsigned int Finger_set_syspar				(unsigned char paramtype , unsigned char paramvalue );
unsigned int Finger_port_control			(unsigned char controlcode);
unsigned int Finger_get_syspar				(unsigned char *str);
unsigned int Finger_get_temp_numb			(unsigned int *tmpnom);
unsigned int Finger_enroll					(void);
unsigned int Finger_get_fing_img			(unsigned int *str );
unsigned int Finger_send_fing_img			(unsigned char *str );
unsigned int Finger_store_fingtobuf12		(unsigned char buffid);
unsigned int Finger_fing_to_temp			(void);
unsigned int Finger_get_fing_temp			(unsigned char buffid , unsigned char *str);
unsigned int Finger_send_fing_temp			(unsigned char buffid , unsigned char *str);
unsigned int Finger_store_fing_temp			(unsigned char buffid , unsigned int locid );
unsigned int Finger_load_fing_temp			(unsigned char buffid , unsigned int pagenom);
unsigned int Finger_delet_fing_temp			(unsigned int pagenom , unsigned int n);
unsigned int Finger_delet_allfing_temp		(void);
unsigned int Finger_match_fing_temp			(unsigned int machscrore );
unsigned int Finger_search_fing_temp		(unsigned int* pagid , unsigned int* machscrore , unsigned char bufferid , unsigned int startpg , unsigned int pagnom);
















#endif
